# EZClient.cpp #

This project aims to assist partners in integrating with the EZTech service, using the APIs in a simple and practical way to serve as an example for a new integration.

# Installation #

To install the EZClient.cpp project follow these steps:

## Step 1 - Clone or Download Project:
[![CloneProject](https://github.com/EZTechBrasil/EZClientCpp/blob/Eric/Pictures/clone-repo-clone-url-button.png)](https://help.github.com/articles/cloning-a-repository/)

## Step 2 - Requirements for execution:
[![Stdio.h](https://img.shields.io/badge/stdio-release-green.svg)](https://sourceforge.net/p/mingw/mingw-org-wsl/ci/21762bb4a1bd0c88c38eead03f59e8d994349e83/tree/include/stdio.h)
[![Stdlib.h](https://img.shields.io/badge/stdlib-release-green.svg)](https://www.tutorialspoint.com/c_standard_library/stdlib_h.htm)
[![Signal.h](https://img.shields.io/badge/signal-release-green.svg)](http://www.uniriotec.br/~morganna/guia/libc/cs_signal.html)
[![String.h](https://img.shields.io/badge/string-release-green.svg)](https://www.tutorialspoint.com/c_standard_library/string_h.htm)

## Win32
[![Conio.h](https://img.shields.io/badge/conio-release-green.svg)](http://equipe.nce.ufrj.br/adriano/c/apostila/funcoes/conio.html)
[![Windows.h](https://img.shields.io/badge/windows-release-green.svg)](https://pt.stackoverflow.com/questions/16495/biblioteca-windows-h-o-que-me-permite-realizar)
[![Tchar.h](https://img.shields.io/badge/tchar-release-green.svg)](https://sourceforge.net/p/mingw/mingw-org-wsl/ci/4.0.0/tree/include/tchar.h)

## Linux
[![Unistd.h](https://img.shields.io/badge/unistd-release-green.svg)](http://pubs.opengroup.org/onlinepubs/7908799/xsh/unistd.h.html)
[![Termios.h](https://img.shields.io/badge/termios-release-green.svg)](http://pubs.opengroup.org/onlinepubs/7908799/xsh/termios.h.html)

[![Sys/ioctl.h](https://img.shields.io/badge/ioctl-release-green.svg)](http://unix.superglobalmegacorp.com/Net2/newsrc/sys/ioctl.h.html)
[![Sys/types.h](https://img.shields.io/badge/types-release-green.svg)](http://pubs.opengroup.org/onlinepubs/009696699/basedefs/sys/types.h.html)
[![Sys/prctl.h](https://img.shields.io/badge/prctl-release-green.svg)](http://man7.org/linux/man-pages/man2/prctl.2.html)
[![Sys/signal.h](https://img.shields.io/badge/signal-release-green.svg)](http://unix.superglobalmegacorp.com/Net2/newsrc/sys/signal.h.html)

## Step 3 - Installing a virtual simulator with manual or automatic deliveries:

[![Quickstart Manual](https://github.com/EZTechBrasil/EZClientCpp/blob/Eric/Pictures/QUICKSTART%20MANUAL.png)](https://github.com/EZTechBrasil/Integracao/raw/master/downloads/INTEGRATION_KIT_QUICKSTART_MANUAL.pdf)

[![Automatic Simulator](https://github.com/EZTechBrasil/EZClientCpp/blob/Eric/Pictures/AUTOMATIC%20SIMULATOR.png)](https://github.com/EZTechBrasil/Integracao/raw/master/downloads/AUTOMATIC_SIMULATOR.pdf)

## Step 4 - Configuring and Running

Open the source code of the project and change the IP address to access the EZServer according to your needs.
[![EZClientCppConfigAdress](https://github.com/EZTechBrasil/EZClientCpp/blob/Eric/Pictures/EZClientCppConfigAdress.png)](https://github.com/EZTechBrasil/EZClientCpp/blob/Eric/Pictures/EZClientCppConfigAdress.png)

Run the application and see it consuming the EZServer information.
[![EZClientCpp](https://github.com/EZTechBrasil/EZClientCpp/blob/Eric/Pictures/EZClientCpp.png)](https://github.com/EZTechBrasil/EZClientCpp/blob/Eric/Pictures/EZClientCpp.png)

## API Reference

For more details on APIs, download the development manual.

[![Quickstart Manual](https://github.com/EZTechBrasil/EZClientCpp/blob/Eric/Pictures/Developer.png)](http://www.execweb.com.br/eztech/EZAdmin/downloads/ManualDesenvolvimento.pdf)
